> For the complete documentation index, see [llms.txt](https://developers.oxylabs.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.oxylabs.io/products/web-scraper-api/features/result-processing-and-storage/cloud-storage/file-name-templating.md).

# File name templating

By default, result files delivered to your cloud storage use the `{{ job_id }}.{{ extension }}`  naming template (e.g., `7346445033316311041.json`). You can specify a custom file naming template for results delivered to your cloud storage.&#x20;

Here's why you may want to do it:

* The result file names can be more informative
* Results can be automatically organized into different directories.

## Template variables

You can use any input parameter you provide when creating a job, as well as any variable from the `job_info` object (found at the bottom of your result) in your file naming template.

## Usage

{% stepper %}
{% step %}

#### Example 1: Custom file name with multiple variables

Writes the result to `oxylabs.test/google_search_test_7336001481897673729.json`

```json
{
    "source": "google_search",
    "query": "test",
    "storage_type": "s3",
    "storage_url": "oxylabs.test/{{ source }}_{{ query }}_{{ job_id }}.{{ extension }}"
}
```

{% endstep %}

{% step %}

#### Example 2: Directory organization

Writes the result to `oxylabs.test/google_search/7336001481897673729.json`

```json
{
    "source": "google_search",
    "query": "test",
    "storage_type": "s3",
    "storage_url": "oxylabs.test/{{ source }}/"
}
```

{% endstep %}

{% step %}

#### Example 3: Custom directory with custom file name

Writes the result to `oxylabs.test/google_search/oxylabs_test_7336001481897673729.json`

```json
{
    "source": "google_search",
    "query": "test",
    "storage_type": "s3",
    "storage_url": "oxylabs.test/{{ source }}/oxylabs_{{ query }}_{{ job_id }}.{{ extension }}"
}
```

{% endstep %}
{% endstepper %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developers.oxylabs.io/products/web-scraper-api/features/result-processing-and-storage/cloud-storage/file-name-templating.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
